//
//  rbg}bvǂݍ g.koutaki 2012
//

#ifndef _BMP_LOADER_
#define _BMP_LOADER_

typedef unsigned long  DWORD;
typedef unsigned short WORD;
typedef long		   LONG;

typedef struct tagBITMAPCOREHEADER {
        DWORD   bcSize;           
        WORD    bcWidth;
        WORD    bcHeight;
        WORD    bcPlanes;
        WORD    bcBitCount;
} BITMAPCOREHEADER;

typedef struct tagBITMAPINFOHEADER{
        DWORD      biSize;
        LONG       biWidth;
        LONG       biHeight;
        WORD       biPlanes;
        WORD       biBitCount;
        DWORD      biCompression;
        DWORD      biSizeImage;
        LONG       biXPelsPerMeter;
        LONG       biYPelsPerMeter;
        DWORD      biClrUsed;
        DWORD      biClrImportant;
} BITMAPINFOHEADER;

typedef struct tagBITMAPFILEHEADER {
        WORD    bfType;
        DWORD   bfSize;
        WORD    bfReserved1;
        WORD    bfReserved2;
        DWORD   bfOffBits;
} BITMAPFILEHEADER;

typedef struct tagBITMAPINFO {
    BITMAPINFOHEADER    bmiHeader;
    DWORD               bmiColors[1];
} BITMAPINFO;

void load_bmp_rgb(char *filename, unsigned char **img, int *w, int *h){

	FILE *fp=fopen(filename, "rb");
	BITMAPINFOHEADER BmpInfoH;
	BITMAPFILEHEADER BmpFileH;
	int x, y, pitch;
	unsigned char line[3*9096];
	int s = sizeof(BITMAPINFOHEADER);
	
	if(fp){
		fread(&BmpFileH, 1, 14, fp);
		fread(&BmpInfoH, 1, 40, fp);
		//@rbg}bv̕߂
		*w=BmpInfoH.biWidth;
		*h=BmpInfoH.biHeight;
		printf("load %s:%dx%d\n", filename, *w, *h);
		(*img) = new unsigned char[*w * *h * 3];
		pitch = (*w * 3 + 3) & ~3;
		//rbg}bvf[^܂Ńt@C|Cgړ
		fseek(fp, 54, SEEK_SET);
		for(y = *h-1; y >= 0 ;y--){
			fread(line, pitch, 1, fp);
			for(x = 0;x < *w; x++){
				(*img)[(x + y * *w)*3 + 0] = line[x * 3 + 2];	// R
				(*img)[(x + y * *w)*3 + 1] = line[x * 3 + 1];	// G
				(*img)[(x + y * *w)*3 + 2] = line[x * 3 + 0];	// B
			};
		};
		fclose(fp);
	};
};


void write_bmp_rgb(char *filename, unsigned char *img, int w, int h){

	FILE *fp=fopen(filename, "wb");
	BITMAPINFOHEADER BmpInfoH;
	BITMAPINFO		 BmpInfo;
	BITMAPFILEHEADER BmpFileH;
	int x, y, pitch;
	unsigned char line[3*9096];
	int s = sizeof(BITMAPFILEHEADER);
	
	if(fp){
		//@rbg}bv̕߂
		pitch = (w * 3 + 3) & ~3;
		memset(&BmpFileH, 0, 14);
		memset(&BmpInfo,  0, 40);
		memset(&BmpInfoH, 0, 40);
		BmpInfo.bmiHeader.biHeight = h;
		BmpInfo.bmiHeader.biWidth = w;
		BmpInfo.bmiHeader.biSize = 40;
		BmpInfo.bmiHeader.biSizeImage = pitch * h;
		BmpInfo.bmiHeader.biPlanes = 1;
		BmpInfo.bmiHeader.biBitCount = 24;
		BmpInfo.bmiHeader.biCompression  = 0;
		BmpInfo.bmiHeader.biClrUsed = 0;
		BmpInfo.bmiHeader.biXPelsPerMeter = 0;
		BmpInfo.bmiHeader.biYPelsPerMeter = 0;
		BmpInfo.bmiHeader.biClrImportant = 0;
		BmpInfoH = BmpInfo.bmiHeader;
		BmpFileH.bfOffBits = 3435921408;
		BmpFileH.bfSize = pitch * h + BmpFileH.bfOffBits;
		BmpFileH.bfType = 19778;
		BmpFileH.bfReserved1 = 0;
		BmpFileH.bfReserved2 = 54;
		printf("write %s:%dx%d\n", filename, w, h);

		fwrite(&BmpFileH, 14, 1, fp);
		fwrite(&BmpInfoH, 40, 1, fp);
		for(y = h - 1; y >= 0;y--){
			for(x = 0;x < w; x++){
				line[x * 3+2] = img[(x + y * w)*3+0];
				line[x * 3+1] = img[(x + y * w)*3+1];
				line[x * 3+0] = img[(x + y * w)*3+2];
			};
			fwrite(line, pitch, 1, fp);
		};
		fclose(fp);
	};
};


#endif


